package com.steerinfo.meterwork.meterworkstorageonline.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.meterwork.meterworkstorageonline.model.MeterWorkStorageOnline;
import com.steerinfo.meterwork.meterworkstorageonline.service.IMeterWorkStorageOnlineService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterWorkStorageOnline RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2020-12-24 07:46
 * 类描述
 * 修订历史：
 * 日期：2020-12-24
 * 作者：generator
 * 参考：
 * 描述：MeterWorkStorageOnline RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/meterworkstorageonlines")
public class MeterWorkStorageOnlineController extends BaseRESTfulController {

    @Autowired
    IMeterWorkStorageOnlineService meterWorkStorageOnlineService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkstorageonline:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterWorkStorageOnline> list = meterWorkStorageOnlineService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkstorageonline:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterWorkStorageOnline> list = meterWorkStorageOnlineService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterWorkStorageOnline对象创建")
    @ApiImplicitParam(name = "meterWorkStorageOnline", value = "详细实体meterWorkStorageOnline", required = true, dataType = "MeterWorkStorageOnline")
    //@RequiresPermissions("meterworkstorageonline:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterWorkStorageOnline model) {
        try {
            MeterWorkStorageOnline meterWorkStorageOnline = meterWorkStorageOnlineService.add(model);
            return success(meterWorkStorageOnline);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkstorageonline:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            MeterWorkStorageOnline meterWorkStorageOnline = meterWorkStorageOnlineService.getById(id);
            return success(meterWorkStorageOnline);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterWorkStorageOnline信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterWorkStorageOnline", value = "详细实体meterWorkStorageOnline", required = true, dataType = "MeterWorkStorageOnline")
    })
    //@RequiresPermissions("meterworkstorageonline:update")
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterWorkStorageOnline model) {
        try {
            model.setId(id);
            MeterWorkStorageOnline meterWorkStorageOnline = meterWorkStorageOnlineService.modify(model);
            return success(meterWorkStorageOnline);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkstorageonline:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        try {
            List<String> list = Arrays.asList(id.split(","));
            if (ListUtils.isNotEmpty(list)) {
                List<String> ids = ListUtils.convertList(list);
                meterWorkStorageOnlineService.delete(ids);
            }
            return success();
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "C#根据传入的实体进行修改")
    @PostMapping(value = "/doSaveWf")
    public RESTfulResult doSaveWf(@RequestBody MeterWorkStorageOnline model) {
        try {
            String no = meterWorkStorageOnlineService.doSaveWf(model);
            return success(no);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }
}
